#include "variable.h"

risc::Variable::Variable(SgVariableDefinition *ast_node):
  Object(ast_node, VariableType)
{
}

std::string
risc::Variable::get_ast_type_name()
{
  SgPointerType *pointer_type = isSgPointerType(ast_type_pointer_);
  if(pointer_type) {
    return pointer_type->get_base_type()->unparseToString();

  } else {
    return ast_type_pointer_->unparseToString();
  }
}

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
