#include "systemc.h"

class MyModule: public sc_module {
public:
  sc_in_clk clk_in;
  int x, y, z;

  SC_HAS_PROCESS(MyModule);

  MyModule(sc_module_name mn): sc_module(mn)
  {
    SC_CTHREAD(my_cthread1, clk_in);
  }

  void my_cthread1()
  {
    /* some initialization */
    z = 42;
    my_other_member_function();

    // First wait statement
    wait();

    while(true) {
      /* computation and communication */
      int l = x * y * z;
      /* computation and communication */
    }
  }

  void my_other_member_function()
  {
    y = 43;
    my_other_member_function2();
  }

  void my_other_member_function2()
  {
    x = 44;
  }
};


int sc_main(int argc, char **argv)
{
  MyModule mm("mm");
//  sc_signal<bool> signal;
//  mm.clk_in.bind(signal);

  sc_start();
  return 0;
}

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
