#include "systemc.h"

class Module: sc_module {

public:
  void thread1()
  {
//    std::cout << "th1, " << sc_time_stamp()
//              << ", " << sc_delta_count() << std::endl;
    event.notify(SC_ZERO_TIME);
    wait(event);

//    std::cout << "th1, " << sc_time_stamp()
//              << ", " << sc_delta_count() << std::endl;
  }

  void thread2()
  {
//    std::cout << "th2, " << sc_time_stamp()
//              << ", " << sc_delta_count() << std::endl;
    wait(event);

//    std::cout << "th2, " << sc_time_stamp()
//              << ", " << sc_delta_count() << std::endl;
    event.notify(SC_ZERO_TIME);
    wait(event);

//    std::cout << "th2, " << sc_time_stamp()
//              << ", " << sc_delta_count() << std::endl;
  }

  SC_HAS_PROCESS(Module);

  sc_event event;

  Module(sc_module_name mn): sc_module(mn) {

    SC_THREAD(thread1);
    SC_THREAD(thread2);
  }
};


int sc_main(int argc, char **argv)
{
  Module m("m");
  sc_start();
  return 0;
}

