#include "function.h"

risc::Function::Function(SgFunctionDefinition *ast_node, Type type):
  Definition(ast_node, type),
  starting_id_(-1)
/************** Added by Guantao Liu 08/28/2015 **************/
  , starting_node_(NULL)
/************** Added by Guantao Liu 08/28/2015 **************/
{
}

SgFunctionDefinition*
risc::Function::get_ast_node()
{
  return isSgFunctionDefinition(ast_node_);
}

std::string risc::Function::get_name()
{
  return SageInterface::get_name(get_ast_node());
}

std::string
risc::Function::get_ast_type_name()
{

  return isSgFunctionType(
             get_ast_node()->get_declaration()->get_type())->unparseToString();
}

/************** Added by Guantao Liu 08/28/2015 **************/
void
risc::Function::set_starting_node(SgNode* starting_node)
{
  starting_node_ = starting_node;
}
/************** Added by Guantao Liu 08/28/2015 **************/

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
